# debug info seem not works with D compiler
%global     snapdate        20120603
%global     gtkd_revision   cb35d25
%global     alphatag        %{snapdate}git%{gtkd_revision}
%global     debug_package   %{nil}


# The source for this package was pulled from upstream's subversion (git).
# Use the following commands to generate the tarball:
# git clone git://github.com/gtkd-developers/GtkD.git
# cd GtkD
# git co Gtk-3.x
# git rev-parse --short HEAD            -> for git_revision
# git checkout %%{gtkd_revision}
# git archive --prefix=gtkd-%%{alphatag}/ HEAD | xz > ../gtkd-%%{alphatag}.tar.xz

Name:           gtkd
Version:        2.0.0
Release:        28.%{alphatag}%{?dist}
Summary:        D binding and OO wrapper of GTK+

# DdocToDevhelp is release to GPLv3+
License:        LGPLv3+ with exceptions
URL:            http://www.dsource.org/projects/derelict/
Source0:        %{name}-%{alphatag}.tar.xz

BuildRequires:  ldc, ldc-phobos-devel, ldc-druntime-devel, gtk2-devel
# Explicit require since gtkd use dlopen internally so rpm can't detect this.
Requires:       atk, gtk2, gdk-pixbuf2, pango, cairo, gdk-pixbuf2, libglade2
Requires:       mesa-libGL, mesa-libGLU, gtksourceview2
Requires:       gstreamer, gstreamer-plugins-base

%description
GTK+ is a highly usable, feature rich toolkit for creating graphical user
interfaces which boasts cross platform compatibility and an easy to use API.

%description -l fr
GTK+ est très utilisable, cet outil contient de nombreuses fonctionnalités
permettant de créer des interfaces graphiques multi-plateforme.
De plus, gtkd fournit une API facile à utiliser.

%package        devel
Summary:        Support for developing gtkd application
Group:          Development/Tools
Requires:       %{name} =  %{version}-%{release}

%description devel
The gtkd-devel package contains header files for developing gtkd
applications.

%description devel -l fr
Le paquet gtkd-devel contient les fichiers d'entêtes pour développer
des applications utilisant gtkd.

%package geany-tags
Summary:        Support for enable autocompletion in geany
Requires:       %{name} =  %{version}-%{release}
BuildArch:      noarch
BuildRequires:  geany
Requires:       geany

%description geany-tags
Enable autocompletion for gtkd library in geany (IDE)

%description -l fr geany-tags
Active l'autocompletion pour pour la bibliothèque gtkd dans geany (IDE)

%prep
%setup -q -n %{name}-%{alphatag}

# temp geany config directory for allow geany to generate tags
mkdir geany_config

%build
make %{?_smp_mflags} -f ./GNUmakefile shared-libs DC=ldc2 CC=gcc libdir=%{?_lib} DCFLAGS="%{_d_optflags}"
# generate geany tags
geany -c geany_config -g gtkd.d.tags $(find src* -name "*.d")

# Need to be update to gtk3
#%check
#make %{?_smp_mflags} test prefix=%{buildroot}%{_prefix} libdir=%{?_lib}

%install
make %{?_smp_mflags} install-shared install-headers prefix=%{buildroot}%{_prefix} libdir=%{?_lib}
# fix right to lib
chmod 755 %{buildroot}%{_libdir}/libgtkd*.so.2.0
# geany tags
mkdir -p %{buildroot}/%{_datadir}/geany/tags/
install -m0644 gtkd.d.tags %{buildroot}/%{_datadir}/geany/tags/

%post               -p  /sbin/ldconfig
%postun             -p  /sbin/ldconfig

%files
%doc AUTHORS COPYING README
#%{_libdir}/libgtkdgl.so.2.0.0 # gtk GL not yes ported to gtk3
#%{_libdir}/libgtkdgl.so.2.0 # same
%{_libdir}/libgtkd.so.2.0.0
%{_libdir}/libgtkd.so.2.0
%{_libdir}/libgtkdsv.so.2.0.0
%{_libdir}/libgtkdsv.so.2.0

%files devel
%{_d_includedir}/atk
%{_d_includedir}/cairo
%{_d_includedir}/gdk
%{_d_includedir}/gdkpixbuf
%{_d_includedir}/gio
#%{_d_includedir}/glade # deprecated for gtk3.x
#%{_d_includedir}/glgdk # gtk GL not yes ported to gtk3
#%{_d_includedir}/glgtk # same
%{_d_includedir}/glib
%{_d_includedir}/gobject
%{_d_includedir}/gsv
%{_d_includedir}/gsvc
%{_d_includedir}/gthread
%{_d_includedir}/gtk
%{_d_includedir}/gtkc
#%{_d_includedir}/gtkglc # gtk GL not yes ported to gtk3
%{_d_includedir}/pango
#%{_libdir}/libgtkdgl.so # gtk GL not yes ported to gtk3
%{_libdir}/libgtkd.so
%{_libdir}/libgtkdsv.so

%files geany-tags
%{_datadir}/geany/tags/gtkd.d.tags

%changelog
* Sun Aug 12 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.0.0-28.20120603gitcb35d25
- temprorally disable check section

* Sun Aug 12 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.0.0-27.20120603gitcb35d25
- Update to lastest revision cb35d25

* Wed Jun 06 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.0.0-26.20120530gitf45bb5b
- update to latest revision 
- build with dmdfe 2.059

* Sat Mar 17 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.0.0-25.20120227git0c468d2
- fix macro in comment

* Thu Mar 15 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.0.0-24.20120227git0c468d2
- latest ldc fix soname issue, the use ldc instead of gcc for this

* Mon Feb 27 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.0.0-23.20120227git0c468d2
- add libglade2 as require
- update to latest revision 0c468d2

* Thu Feb 23 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.0.0-22.20120219git2cfd194
- Fix license

* Mon Feb 20 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.0.0-21.20120219git2cfd194
- source move to github
- fix license
- update to latest git rev

* Tue Feb 14 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.0.0-20.20120208svn933
- Update to latest svn rev 933

* Sun Feb 05 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.0.0-19.20120205svn932
- Update to latest svn rev 932

* Sat Feb 04 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.0.0-18.20120204svn928
- Update to latest svn rev 928

* Fri Feb 03 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.0.0-17.20120201svn927
- update to rev svn 927

* Tue Jan 31 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.0.0-16.20120130svn924
- update to latest svn rev 924

* Sat Jan 28 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.0.0-15.20120113svn920
- Enable shared lib

* Thu Jan 19 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.0.0-14.20120113svn920
- Remove %%file devel section

* Thu Jan 19 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2.0.0-13.20120113svn920
- Do not build as shared lib do not works yet
- Remove 'it is a' from Summary
- gtkd load shared lib at runtime with dlopen then add corresponding requires
- Change gtkd code source for use versioned lib

* Mon Jan 16 2012 Jonathan MERCIER <bioinfornatics at gmail.com> 2.0.0-12.20120113svn920
- remove require devel from non devel (sub)package
- remove require gtk2-devel from -devel
- apply %%post and %%postun on main package

* Fri Jan 13 2012 Jonathan MERCIER <bioinfornatics at gmail.com> 2.0.0-11.20120113svn920
- update to latest release who fix a problem around soname

* Fri Jan 13 2012 Jonathan MERCIER <bioinfornatics at gmail.com> 2.0.0-10.20120113svn919
- update to latest release who he apply my patch

* Tue Jan 10 2012 Jonathan MERCIER <bioinfornatics at gmail.com> 2.0.0-9.20120111svn915
- update to latest release
- fix fsf adress
- fix soname
- add devel package
- little change in french description
- add geany tag and devhelp supackage to noarch

* Sun Jan 8 2012 Jonathan MERCIER <bioinfornatics at gmail.com> 2.0.0-8.201110243svn906
- prefix python script by python command

* Sun Dec 11 2011 Jonathan MERCIER <bioinfornatics at gmail.com> 2.0.0-7.201110243svn906
- remove %%defattr and Group section
- generate devhelp book in  %%build section

* Fri Dec 9 2011  Jonathan MERCIER <bioinfornatics at gmail.com> 2.0.0-6.201110243svn906
- Add doc for devhelp
- Add tag for geany

* Mon Oct 24 2011 Jonathan MERCIER <bioinfornatics at gmail.com> 2.0.0-5.201110243svn906
- Update to release 906

* Mon Sep 19 2011 Jonathan MERCIER <bioinfornatics at gmail.com> 2.0.0-4.20110915svn897
- Update to release 897

* Mon Aug 02 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2.0.0-3.20100720svn797
- fix gtkd spec

* Mon Aug 02 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2.0.0-2.20100720svn797
- Update to release 797

* Sun Jul 04 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2.0.0-1.20100407svn796
- Initial release
